#ifndef __DMA_RING_BUFFER_H__
#define __DMA_RING_BUFFER_H__

#include <stdbool.h>
#include <stm32f4xx.h>
#include <stddef.h>

struct dma_ring_buffer_to_mem {
	void *data_ptr;
	size_t buffer_count;
	DMA_Stream_TypeDef *dma;
	size_t get_idx;
	uint8_t base_dma_id;
	size_t element_size;
};

int dma_ring_buffer_periph_to_mem_initialize(struct dma_ring_buffer_to_mem *dma_buffer, uint8_t base_dma_id, DMA_Stream_TypeDef *dma_stream, size_t buffer_element_count, size_t element_size, void *data_buffer, void *src_reg, uint8_t dma_trigger_channel);
int dma_ring_buffer_periph_to_mem_get_data(struct dma_ring_buffer_to_mem *buff, const void **data_buff, size_t *len);
void dma_ring_buffer_periph_to_mem_stop(struct dma_ring_buffer_to_mem *buff);
#endif /* __DMA_RING_BUFFER_H__ */



